package com.ssm.controller;


import javax.persistence.Column;
import javax.persistence.Id;

import com.github.pagehelper.PageInfo;
import com.ssm.manage.entity.RlMenuPower;
import com.ssm.manage.dto.RlMenuPowerDto;
import com.ssm.manage.response.GenericResponse;
import com.ssm.manage.response.PageResponse;
import com.ssm.manage.response.ResponseCode;
import com.ssm.manage.service.RlMenuPowerService;
import org.springframework.web.bind.annotation.*;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;

import java.io.Serializable;

import lombok.extern.slf4j.Slf4j;
import com.ssm.core.utils.SnowflakeUtil;

import java.util.Random;

/**
 * 菜单权限(RlMenuPower)表控制层
 *
 * @author makejava
 * @since 2023-12-13 15:34:05
 */
@RestController
@RequestMapping("rlMenuPower")
@Slf4j
@Api(tags = "菜单权限")
public class RlMenuPowerController {
    /**
     * 服务对象
     */
    @Autowired
    private RlMenuPowerService rlMenuPowerService;

/**
 * 通过主键查询单条数据
 *
 * @param id 主键
 * @return
 @GetMapping("{id}")
 @ApiOperation("通过主键查询单条数据")
 //@RequiresPermissions("system:rlMenuPower:query")
 public ResultVo get(@PathVariable Serializable id) {
 return this.rlMenuPowerService.queryById(id);
 }
 */


    /**
     * 分页查询菜单权限
     *
     * @param dto
     * @return
     */
    @GetMapping
    @ApiOperation("分页查询菜单权限")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "页码", defaultValue = "1", required = true),
            @ApiImplicitParam(name = "pageSize", value = "每页数量", defaultValue = "10", required = true)
    })
//@RequiresPermissions("system:rlMenuPower:query")
    public PageResponse<RlMenuPower> listPage(RlMenuPowerDto dto) {
        PageResponse<RlMenuPower> pageResponse = new PageResponse<>();
        PageInfo<RlMenuPower> pageInfo = new PageInfo<>();
        try {
            pageInfo = this.rlMenuPowerService.selectPage(dto);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.selectPage", e);
            pageResponse.setCodeAndMsg(ResponseCode.FAILED);
            return pageResponse;
        }
        pageResponse.setPageInfo(pageInfo);
        pageResponse.setCodeAndMsg(ResponseCode.OK);
        return pageResponse;
    }

    /**
     * 新增菜单权限
     *
     * @param rlMenuPower
     * @return
     */
    @PostMapping
    @ApiOperation("新增菜单权限")
//@RequiresPermissions("system:rlMenuPower:add")
    public GenericResponse add(@RequestBody RlMenuPower rlMenuPower) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
//            rlMenuPower.setId(new SnowflakeUtil(new Random().nextInt(1023)).nextId());
            i = this.rlMenuPowerService.save(rlMenuPower);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

    /**
     * 编辑菜单权限
     *
     * @param rlMenuPower
     * @return
     */
    @PutMapping
    @ApiOperation("编辑菜单权限")
//@RequiresPermissions("system:rlMenuPower:edit")
    public GenericResponse edit(@RequestBody RlMenuPower rlMenuPower) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
            i = this.rlMenuPowerService.updateByPrimaryKey(rlMenuPower);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }

    /**
     * 根据主键删除菜单权限
     *
     * @param id 主键
     * @return
     */
    @DeleteMapping("{id}")
    @ApiOperation("根据主键删除菜单权限")
//@RequiresPermissions("system:rlMenuPower:delete")
    public GenericResponse delete(@PathVariable Long id) {
        GenericResponse genericResponse = new GenericResponse();
        int i = 0;
        try {
            RlMenuPower rlMenuPower = new RlMenuPower();
//            rlMenuPower.setId(id);
            i = this.rlMenuPowerService.delete(rlMenuPower);
        } catch (Exception e) {
            log.error("SsmCollectionTypeController.add:", e);
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
            return genericResponse;
        }
        if (i > 0) {
            genericResponse.setCodeAndMsg(ResponseCode.OK);
        } else {
            genericResponse.setCodeAndMsg(ResponseCode.FAILED);
        }
        return genericResponse;
    }



}
